import { shallow } from 'enzyme';
import React from 'react';
import Modal from '../../modal';
import Alert from '../Alert';
describe('Alert', function () {
  it('should render correctly', function () {
    var wrapper = shallow( /*#__PURE__*/React.createElement(Alert, {
      animationType: "door"
    }));
    expect(wrapper.find(Modal)).toHaveLength(1);
    expect(wrapper.prop('className')).toEqual('za-alert za-alert--radius');
  });
  it('should render default locale cancel text for the button inside footer', function () {
    var wrapper = shallow( /*#__PURE__*/React.createElement(Alert, null));
    var button = wrapper.find(Modal).prop('footer');
    expect(button.props).toEqual({
      type: 'button',
      className: 'za-alert__button',
      onClick: undefined,
      children: '关闭'
    });
  });
  it('should render default locale cancel text for the button inside footer', function () {
    var onCancel = jest.fn();
    var wrapper = shallow( /*#__PURE__*/React.createElement(Alert, {
      onCancel: onCancel,
      cancelText: "close"
    }));
    var button = wrapper.find(Modal).prop('footer');
    expect(button.props).toEqual({
      type: 'button',
      className: 'za-alert__button',
      onClick: onCancel,
      children: 'close'
    });
  });
  it('should handle button click', function () {
    var onCancel = jest.fn();
    var wrapper = shallow( /*#__PURE__*/React.createElement(Alert, {
      onCancel: onCancel
    }));
    var button = wrapper.find(Modal).prop('footer');
    button.props.onClick();
    expect(onCancel).toBeCalledTimes(1);
  });
});