import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/* eslint-disable @typescript-eslint/no-var-requires */

/* eslint-disable prefer-destructuring */

/* eslint-disable dot-notation */
import React from 'react';
import { shallow, mount } from 'enzyme';
import toJson from 'enzyme-to-json';
import BackToTop from '../index';
import Scroller from '../../scroller';

function genItems(count) {
  var list = [];

  for (var i = 0; i < count; i++) {
    list.push( /*#__PURE__*/React.createElement("li", {
      key: +i
    }, "\u7B2C ", i + 1, " \u884C"));
  }

  return list;
}

describe('BackToTop', function () {
  var scrollTo;
  var BackToTopCJS;
  beforeAll(function () {
    scrollTo = window.scrollTo;
    window.scrollTo = jest.fn();
  });
  beforeEach(function () {
    jest.resetModules();
  });
  afterEach(function () {
    jest.restoreAllMocks();
  });
  afterAll(function () {
    window.scrollTo = scrollTo;
  });
  describe('snapshot', function () {
    it('renders correctly', function () {
      var wrapper = mount( /*#__PURE__*/React.createElement(BackToTop, null, "Up"));
      expect(toJson(wrapper)).toMatchSnapshot();
    });
    it('scrollContainer', function () {
      var containerStyle = {
        overflowY: 'auto',
        maxHeight: 400
      };
      var container;
      var wrapper = mount( /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("ul", {
        ref: function ref(ele) {
          container = ele;
        },
        style: containerStyle
      }, genItems(100)), /*#__PURE__*/React.createElement(BackToTop, {
        scrollContainer: function scrollContainer() {
          return container;
        }
      }, "Up")));
      expect(toJson(wrapper)).toMatchSnapshot();
    });
  });
  it('should handle click event and scroll to the top with animation', function () {
    var onClick = jest.fn();
    var wrapper = shallow( /*#__PURE__*/React.createElement(BackToTop, {
      onClick: onClick
    }, "Up"));
    window.scrollTo(0, 1000);
    jest.useFakeTimers();
    wrapper.find('.za-back-to-top').simulate('click');
    jest.runAllTimers();
    expect(window.scrollTo).toBeCalledWith(0, 0);
    expect(onClick).toBeCalled();
  });
  it('should scroll to the top immediately without animation ', function () {
    var wrapper = shallow( /*#__PURE__*/React.createElement(BackToTop, {
      speed: 0
    }, "Up"));
    window.scrollTo(0, 1000);
    wrapper.find('.za-back-to-top').simulate('click');
    expect(window.scrollTo).toBeCalledWith(0, 0);
  });
  it('should append portal container to document body when component did mount', function () {
    var appendChildSpy = jest.spyOn(document.body, 'appendChild');
    var createElementSpy = jest.spyOn(document, 'createElement');
    var wrapper = shallow( /*#__PURE__*/React.createElement(BackToTop, null, "Up"));
    expect(createElementSpy).toBeCalledWith('div');
    expect(appendChildSpy).toBeCalledWith(wrapper.instance()['portalContainer']);
    var portalContainer = document.body.querySelector('.za-back-to-top-container');
    expect(portalContainer).toBeTruthy();
  });
  it('should remove portal container from the document body when component will unmount', function () {
    var removeChildSpy = jest.spyOn(document.body, 'removeChild');
    var wrapper = shallow( /*#__PURE__*/React.createElement(BackToTop, null, "Up"));
    var portalContainer = wrapper.instance()['portalContainer'];
    wrapper.unmount();
    expect(removeChildSpy).toBeCalledWith(portalContainer);
  });
  it('should render null if environment does NOT support DOM', function () {
    jest.doMock('../../utils/dom', function () {
      var oDom = jest.requireActual('../../utils/dom');
      return _objectSpread(_objectSpread({}, oDom), {}, {
        canUseDOM: false
      });
    });
    BackToTopCJS = require('../index').default;
    var wrapper = shallow( /*#__PURE__*/React.createElement(BackToTopCJS, null, "Up"));
    expect(BackToTopCJS.defaultProps.scrollContainer).toBeUndefined();
    expect(wrapper.instance()['parent']).toEqual(document.body);
    expect(wrapper.isEmptyRender()).toBeTruthy();
  });
  it('should handle scroll and set visible to false if scrollTop greater than props.visibleDistance', function () {
    var wrapper = shallow( /*#__PURE__*/React.createElement(BackToTop, null, "Up"));
    wrapper.find(Scroller).invoke('onScroll')(300);
    expect(wrapper.find('.za-back-to-top').prop('style')).toEqual({
      display: 'none',
      position: 'fixed',
      bottom: 50,
      right: 50
    });
  });
  it('should use scrollContainer as this.parent', function () {
    var scrollContainer = document.createElement('div');
    var wrapper = mount( /*#__PURE__*/React.createElement(BackToTop, {
      scrollContainer: scrollContainer
    }, "Up"));
    expect(wrapper.instance()['parent']).toEqual(scrollContainer);
  });
  it('should append new portal container if scrollContainer changed', function () {
    var appendChildSpy = jest.spyOn(document.body, 'appendChild');
    var scrollContainer = document.createElement('div');
    var wrapper = mount( /*#__PURE__*/React.createElement(BackToTop, null, "Up"));
    wrapper.setProps({
      scrollContainer: scrollContainer
    });
    expect(appendChildSpy).toBeCalledWith(wrapper.instance()['portalContainer']);
  });
  it('should render portal with correct style', function () {
    var scrollContainer = document.createElement('div');
    var wrapper = mount( /*#__PURE__*/React.createElement(BackToTop, {
      scrollContainer: scrollContainer,
      style: {
        color: 'blue'
      }
    }, "Up"));
    wrapper.find(Scroller).invoke('onScroll')(500);
    expect(wrapper.find('.za-back-to-top').prop('style')).toEqual({
      display: 'inline',
      position: 'absolute',
      bottom: 50,
      right: 50,
      color: 'blue'
    });
  });
});