import React from 'react';
import { mount } from 'enzyme';
import toJson from 'enzyme-to-json';
import DatePickerView from '../DatePickerView';
import DatePickerViewEnhanced from '../index';
describe('DatePickerView', function () {
  afterEach(function () {
    jest.restoreAllMocks();
  });
  it('DatePickerView time', function () {
    jest.spyOn(DatePickerView.prototype, 'getColsValue').mockReturnValue({
      dataSource: [],
      value: [2021]
    });
    var wrapper = mount( /*#__PURE__*/React.createElement(DatePickerViewEnhanced, {
      mode: "datetime",
      defaultValue: "2017-12-3 14:00"
    }));
    expect(toJson(wrapper)).toMatchSnapshot();
  });
  it('DatePickerView time 2', function () {
    jest.spyOn(DatePickerView.prototype, 'getColsValue').mockReturnValue({
      dataSource: [{
        label: 1988,
        value: 1988
      }],
      value: [2021]
    });
    var wrapper = mount( /*#__PURE__*/React.createElement(DatePickerViewEnhanced, {
      mode: "datetime",
      min: "2007-01-03 11:00",
      max: "2019-11-23 21:00"
    }));
    expect(toJson(wrapper)).toMatchSnapshot();
  });
  it('DatePickerView time 3', function () {
    var wrapper = mount( /*#__PURE__*/React.createElement(DatePickerViewEnhanced, {
      mode: "time",
      value: "14:00",
      min: "11:00",
      max: "21:00"
    }));
    expect(toJson(wrapper)).toMatchSnapshot();
  });
});