import { isObject, isString } from '../../utils/validate';
import LOAD_STATUS from './loadStatus';

function isImageString(image) {
  return isString(image);
}

function isImageObject(image) {
  return isObject(image);
}

var formatImages = function formatImages(images) {
  var previewImages = [];
  (images || []).forEach(function (image) {
    if (isImageString(image)) {
      previewImages.push({
        url: image
      });
    } else if (isImageObject(image)) {
      previewImages.push({
        url: image.url,
        originUrl: image.originUrl,
        loaded: LOAD_STATUS.before
      });
    }
  });
  return previewImages;
};

export default formatImages;