import React from 'react';
import { mount } from 'enzyme';
import toJson from 'enzyme-to-json';
import KeyboardPicker from '../index';
describe('KeyboardPicker', function () {
  describe('snapshot', function () {
    it('renders correctly', function () {
      var wrapper = mount( /*#__PURE__*/React.createElement(KeyboardPicker, null));
      expect(toJson(wrapper)).toMatchSnapshot();
    });
  });
  it('should handle number key click event', function () {
    var mOnKeyClick = jest.fn();
    var wrapper = mount( /*#__PURE__*/React.createElement(KeyboardPicker, {
      visible: true,
      onKeyClick: mOnKeyClick
    }));
    expect(wrapper.state('visible')).toBeTruthy();
    wrapper.find('.za-keyboard__item').at(0).simulate('click');
    expect(mOnKeyClick).toBeCalledWith('1');
    expect(wrapper.state('visible')).toBeTruthy();
  });
  it('should handle "ok" key click event', function () {
    var mOnKeyClick = jest.fn();
    var wrapper = mount( /*#__PURE__*/React.createElement(KeyboardPicker, {
      visible: true,
      onKeyClick: mOnKeyClick
    }));
    expect(wrapper.state('visible')).toBeTruthy();
    wrapper.find('.za-keyboard__item--ok').simulate('click');
    expect(mOnKeyClick).toBeCalledWith('ok');
    expect(wrapper.state('visible')).toBeTruthy();
  });
});