"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _modal = _interopRequireDefault(require("../../modal"));

var _Alert = _interopRequireDefault(require("../Alert"));

describe('Alert', function () {
  it('should render correctly', function () {
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_Alert.default, {
      animationType: "door"
    }));
    expect(wrapper.find(_modal.default)).toHaveLength(1);
    expect(wrapper.prop('className')).toEqual('za-alert za-alert--radius');
  });
  it('should render default locale cancel text for the button inside footer', function () {
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_Alert.default, null));
    var button = wrapper.find(_modal.default).prop('footer');
    expect(button.props).toEqual({
      type: 'button',
      className: 'za-alert__button',
      onClick: undefined,
      children: '关闭'
    });
  });
  it('should render default locale cancel text for the button inside footer', function () {
    var onCancel = jest.fn();
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_Alert.default, {
      onCancel: onCancel,
      cancelText: "close"
    }));
    var button = wrapper.find(_modal.default).prop('footer');
    expect(button.props).toEqual({
      type: 'button',
      className: 'za-alert__button',
      onClick: onCancel,
      children: 'close'
    });
  });
  it('should handle button click', function () {
    var onCancel = jest.fn();
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_Alert.default, {
      onCancel: onCancel
    }));
    var button = wrapper.find(_modal.default).prop('footer');
    button.props.onClick();
    expect(onCancel).toBeCalledTimes(1);
  });
});