"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _DatePickerView = _interopRequireDefault(require("../DatePickerView"));

var _index = _interopRequireDefault(require("../index"));

describe('DatePickerView', function () {
  afterEach(function () {
    jest.restoreAllMocks();
  });
  it('DatePickerView time', function () {
    jest.spyOn(_DatePickerView.default.prototype, 'getColsValue').mockReturnValue({
      dataSource: [],
      value: [2021]
    });
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, {
      mode: "datetime",
      defaultValue: "2017-12-3 14:00"
    }));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('DatePickerView time 2', function () {
    jest.spyOn(_DatePickerView.default.prototype, 'getColsValue').mockReturnValue({
      dataSource: [{
        label: 1988,
        value: 1988
      }],
      value: [2021]
    });
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, {
      mode: "datetime",
      min: "2007-01-03 11:00",
      max: "2019-11-23 21:00"
    }));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('DatePickerView time 3', function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, {
      mode: "time",
      value: "14:00",
      min: "11:00",
      max: "21:00"
    }));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
});