"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDaysInMonth = getDaysInMonth;
exports.pad = exports.setMonth = exports.cloneDate = exports.getGregorianCalendar = void 0;

var getGregorianCalendar = function getGregorianCalendar(year, month, day, hour, minutes, seconds) {
  return new Date(year, month, day, hour, minutes, seconds);
};

exports.getGregorianCalendar = getGregorianCalendar;

var cloneDate = function cloneDate(date) {
  return new Date(+date);
}; // 获取当月天数


exports.cloneDate = cloneDate;

function getDaysInMonth(date) {
  return new Date(date.getFullYear(), date.getMonth() + 1, 0).getDate();
}

var setMonth = function setMonth(date, month) {
  date.setDate(Math.min(date.getDate(), getDaysInMonth(new Date(date.getFullYear(), month))));
  date.setMonth(month);
}; // 补齐格式


exports.setMonth = setMonth;

var pad = function pad(n) {
  return n < 10 ? "0".concat(n) : n;
};

exports.pad = pad;