"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _index = _interopRequireDefault(require("../index"));

var _en_US = _interopRequireDefault(require("../../date-picker-view/locale/en_US"));

var _date = require("../../../tests/testData/date");

describe('DateSelect', function () {
  it('DateSelect year', function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, {
      title: "\u9009\u62E9\u5E74\u4EFD",
      placeholder: "\u8BF7\u9009\u62E9\u5E74\u4EFD",
      mode: "year",
      value: "2017",
      locale: _en_US.default
    }));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('DateSelect trigger visible', function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, {
      mode: "date",
      defaultValue: _date.date1
    }));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('DateSelect disabled', function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, {
      disabeld: true,
      dataSource: [{
        value: '1',
        label: '选项一'
      }, {
        value: '2',
        label: '选项二'
      }],
      value: _date.date1
    }));
    wrapper.find('.za-date-select').simulate('click');
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('DateSelect date', function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, {
      title: "\u9009\u62E9\u65E5\u671F",
      placeholder: "\u8BF7\u9009\u62E9\u65E5\u671F",
      mode: "date",
      value: _date.date1
    }));
    wrapper.setProps({
      value: _date.date1
    });
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('DateSelect time', function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, {
      title: "\u9009\u62E9\u65F6\u95F4",
      placeholder: "\u8BF7\u9009\u62E9\u65F6\u95F4",
      mode: "time",
      defaultValue: _date.date2,
      minuteStep: 15
    }));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('DateSelect datetime', function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, {
      title: "\u9009\u62E9\u65F6\u95F4",
      placeholder: "\u8BF7\u9009\u62E9\u65F6\u95F4",
      mode: "datetime",
      min: _date.date3,
      max: _date.date4,
      defaultValue: _date.date5
    }));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
    wrapper.setProps({
      defaultValue: _date.date6,
      value: _date.date6
    });
  });
  it('DateSelect wheelDefaultValue', function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, {
      title: "\u9009\u62E9\u65E5\u671F",
      placeholder: "\u8BF7\u9009\u62E9\u65E5\u671F",
      mode: "date",
      wheelDefaultValue: _date.date5
    }));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  }); // it('should trigger onOk when press ok button', () => {
  //   const onOkFn = jest.fn();
  //   const wrapper = mount(
  //     <DateSelect
  //       mode="date"
  //       value="2009-3-4"
  //       onOk={onOkFn}
  //     />,
  //   );
  //   wrapper.find('.za-date-picker__submit').simulate('click');
  //   expect(onOkFn).toBeCalled();
  // });
  // it('should trigger onCancel when press cancel button', () => {
  //   const onCancelFn = jest.fn();
  //   const wrapper = mount(
  //     <DateSelect
  //       mode="date"
  //       value="2009-3-4"
  //       onCancel={onCancelFn}
  //     />,
  //   );
  //   wrapper.find('.za-date-picker__cancel').simulate('click');
  //   expect(onCancelFn).toBeCalled();
  // });
  // it('should trigger onMaskClick when click mask', () => {
  //   const onMaskClick = jest.fn();
  //   const wrapper = mount(
  //     <DateSelect
  //       mode="date"
  //       value="2009-3-4"
  //       visible
  //       onMaskClick={onMaskClick}
  //     />
  //   );
  //   wrapper.find('.za-mask').simulate('click');
  //   expect(onMaskClick).toBeCalled();
  // });
});