"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _validate = require("../../utils/validate");

var _loadStatus = _interopRequireDefault(require("./loadStatus"));

function isImageString(image) {
  return (0, _validate.isString)(image);
}

function isImageObject(image) {
  return (0, _validate.isObject)(image);
}

var formatImages = function formatImages(images) {
  var previewImages = [];
  (images || []).forEach(function (image) {
    if (isImageString(image)) {
      previewImages.push({
        url: image
      });
    } else if (isImageObject(image)) {
      previewImages.push({
        url: image.url,
        originUrl: image.originUrl,
        loaded: _loadStatus.default.before
      });
    }
  });
  return previewImages;
};

var _default = formatImages;
exports.default = _default;