"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _index = _interopRequireDefault(require("../index"));

describe('KeyboardPicker', function () {
  describe('snapshot', function () {
    it('renders correctly', function () {
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, null));
      expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
    });
  });
  it('should handle number key click event', function () {
    var mOnKeyClick = jest.fn();
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, {
      visible: true,
      onKeyClick: mOnKeyClick
    }));
    expect(wrapper.state('visible')).toBeTruthy();
    wrapper.find('.za-keyboard__item').at(0).simulate('click');
    expect(mOnKeyClick).toBeCalledWith('1');
    expect(wrapper.state('visible')).toBeTruthy();
  });
  it('should handle "ok" key click event', function () {
    var mOnKeyClick = jest.fn();
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_index.default, {
      visible: true,
      onKeyClick: mOnKeyClick
    }));
    expect(wrapper.state('visible')).toBeTruthy();
    wrapper.find('.za-keyboard__item--ok').simulate('click');
    expect(mOnKeyClick).toBeCalledWith('ok');
    expect(wrapper.state('visible')).toBeTruthy();
  });
});