"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _index = _interopRequireDefault(require("./style/index.native"));

var _renderWithText = require("../utils/renderWithText.native");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var messageStyles = _reactNative.StyleSheet.create(_index.default);

var Message = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2.default)(Message, _PureComponent);

  var _super = _createSuper(Message);

  function Message(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Message);
    _this = _super.call(this, props);

    _this.onPressClose = function () {
      _this.setState({
        visible: false
      });
    };

    _this.state = {
      visible: true
    };
    return _this;
  }

  (0, _createClass2.default)(Message, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          theme = _this$props.theme,
          icon = _this$props.icon,
          hasArrow = _this$props.hasArrow,
          closable = _this$props.closable,
          styles = _this$props.styles,
          style = _this$props.style,
          onClick = _this$props.onClick,
          children = _this$props.children,
          size = _this$props.size;
      var visible = this.state.visible;
      var wrapperStyle = [styles.wrapper, styles["".concat(theme, "Wrapper")], styles["".concat(size, "Wrapper")], style];
      var textStyle = [styles["".concat(theme, "TextStyle")], styles["".concat(size, "TextStyle")]];
      var arrowStyle = [styles.arrowStyle, styles["".concat(theme, "ArrowStyle")], styles["".concat(size, "ArrowStyle")]];
      var closeIconStyle = [styles.closeIconStyle, styles["".concat(theme, "CloseIconStyle")], styles["".concat(size, "CloseIconStyle")]];

      var closeRender = closable && /*#__PURE__*/_react.default.createElement(_reactNative.TouchableWithoutFeedback, {
        onPress: this.onPressClose
      }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: styles.closeIconWrapperStyle
      }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: [closeIconStyle, styles.closeIconLeft]
      }), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: [closeIconStyle, styles.closeIconRight]
      })));

      var arrowRender = hasArrow && /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: styles.arrowWrapperStyle
      }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: arrowStyle
      }));

      var footerRender = (closable || hasArrow) && /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: styles.footerStyle
      }, closeRender, arrowRender);

      var messageRender = /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: wrapperStyle
      }, icon && /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: styles.headerStyle
      }), /*#__PURE__*/_react.default.createElement(_renderWithText.RenderWithText, {
        viewStyle: styles.bodyStyle,
        textStyle: textStyle,
        component: children
      }), footerRender);

      var wrapperProps = {
        onPress: onClick
      };
      return visible && (onClick ? /*#__PURE__*/_react.default.createElement(_reactNative.TouchableWithoutFeedback, wrapperProps, messageRender) : messageRender);
    }
  }]);
  return Message;
}(_react.PureComponent);

exports.default = Message;
Message.defaultProps = {
  theme: 'primary',
  size: 'md',
  hasArrow: false,
  closable: false,
  styles: messageStyles
};