"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _RadioGroup = _interopRequireDefault(require("../RadioGroup"));

var _index = _interopRequireDefault(require("../index"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TestRadio = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(TestRadio, _React$Component);

  var _super = _createSuper(TestRadio);

  function TestRadio() {
    (0, _classCallCheck2.default)(this, TestRadio);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(TestRadio, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react.default.createElement("input", this.props);
    }
  }]);
  return TestRadio;
}(_react.default.Component);

describe('Radio', function () {
  it('renders correctly', function () {
    var wrapper = (0, _enzyme.render)( /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "0"
    }, "\u9009\u9879\u4E00"));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('defaultChecked', function () {
    var wrapper = (0, _enzyme.render)( /*#__PURE__*/_react.default.createElement(_index.default, {
      defaultChecked: true,
      value: "0"
    }, "\u9009\u9879\u4E00"));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('type is button', function () {
    var wrapper = (0, _enzyme.render)( /*#__PURE__*/_react.default.createElement(_index.default, {
      type: "button",
      value: "0"
    }, "\u9009\u9879\u4E00"));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('type is cell', function () {
    var wrapper = (0, _enzyme.render)( /*#__PURE__*/_react.default.createElement(_index.default, {
      type: "cell",
      value: "0"
    }, "\u9009\u9879\u4E00"));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('receive new checked', function () {
    var onChange = jest.fn();
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "0",
      onChange: onChange
    }, "\u9009\u9879\u4E00"));
    wrapper.setProps({
      checked: true
    });
    wrapper.find('input[type="radio"]').simulate('change');
    expect(onChange).toBeCalled();
  });
  it('disabled', function () {
    var onChange = jest.fn();
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "0",
      onChange: onChange
    }, "\u9009\u9879\u4E00"));
    wrapper.setProps({
      disabled: true
    });
    wrapper.find('input[type="radio"]').simulate('change');
  });
});
describe('Radio.Group', function () {
  describe('#getDerivedStateFromProps', function () {
    it('should get derived state from props correctly', function () {
      var props = {
        value: 1
      };

      var state = _RadioGroup.default.getDerivedStateFromProps(props);

      expect(state).toEqual({
        value: 1
      });
    });
    it('should return null if  value field not in props', function () {
      var props = {};

      var state = _RadioGroup.default.getDerivedStateFromProps(props);

      expect(state).toBeNull();
    });
  });
  describe('#getValue', function () {
    it('should get initial state from props correctly if props has value field', function () {
      var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_RadioGroup.default, {
        value: 1
      }));
      expect(wrapper.state()).toEqual({
        value: 1
      });
    });
    it('should get initial state from props correctly if props has defaultValue field', function () {
      var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_RadioGroup.default, {
        defaultValue: 1
      }));
      expect(wrapper.state()).toEqual({
        value: 1
      });
    });
    it('should get null', function () {
      var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_RadioGroup.default, null));
      expect(wrapper.state()).toEqual({
        value: null
      });
    });
  });
  describe('#getChildChecked', function () {
    it('should get initial state from props correctly if component has single child', function () {
      var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_RadioGroup.default, null, /*#__PURE__*/_react.default.createElement(TestRadio, {
        checked: true,
        value: 233
      })));
      expect(wrapper.state()).toEqual({
        value: 233
      });
    });
    it('should get initial state from props correctly if component has children', function () {
      var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_RadioGroup.default, null, /*#__PURE__*/_react.default.createElement(TestRadio, {
        checked: true,
        value: 233
      }), /*#__PURE__*/_react.default.createElement(TestRadio, {
        checked: true,
        value: 222
      })));
      expect(wrapper.state()).toEqual({
        value: 222
      });
    });
    it('should get initial state from props correctly if component has invalid React element child', function () {
      var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_RadioGroup.default, null, /*#__PURE__*/_react.default.createElement(TestRadio, {
        checked: false,
        value: 110
      })));
      expect(wrapper.state()).toEqual({
        value: null
      });
    });
  });
  it('should render with children', function () {
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_RadioGroup.default, {
      id: "test-radio-group"
    }, /*#__PURE__*/_react.default.createElement(TestRadio, {
      value: 1,
      checked: false
    }), /*#__PURE__*/_react.default.createElement(TestRadio, {
      value: 2,
      checked: false
    })));
    expect(wrapper.find('.za-radio-group__inner').children()).toHaveLength(2);
    expect(wrapper.prop('id')).toEqual('test-radio-group');
  });
  it('should render with cloned react element correctly', function () {
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_RadioGroup.default, {
      id: "test-radio-group",
      type: "button"
    }, /*#__PURE__*/_react.default.createElement(TestRadio, {
      value: 1
    }), /*#__PURE__*/_react.default.createElement(TestRadio, {
      value: 2
    })));
    expect(wrapper.find(TestRadio).at(0).props()).toEqual({
      value: 1,
      checked: false,
      type: 'button',
      shape: 'radius',
      disabled: false,
      onChange: expect.any(Function)
    });
    expect(wrapper.find(TestRadio).at(1).props()).toEqual({
      value: 2,
      checked: false,
      type: 'button',
      shape: 'radius',
      disabled: false,
      onChange: expect.any(Function)
    });
  });
  it('should handle onChange event on radio group component', function () {
    var onChange = jest.fn();
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_RadioGroup.default, {
      id: "test-radio-group",
      onChange: onChange
    }, /*#__PURE__*/_react.default.createElement(TestRadio, {
      value: 1,
      checked: false
    }), /*#__PURE__*/_react.default.createElement(TestRadio, {
      value: 2,
      checked: false
    })));
    expect(wrapper.state('value')).toBeNull();
    var input = wrapper.find('.za-radio-group__inner').children().at(0).find('input');
    expect(input.props()).toEqual(expect.objectContaining({
      value: 1,
      checked: false,
      type: undefined,
      shape: 'radius',
      disabled: false,
      onChange: expect.any(Function)
    }));
    input.simulate('change');
    expect(onChange).toBeCalledWith(1);
    expect(wrapper.state('value')).toEqual(1);
  });
  it('should handle onChange event on the children', function () {
    var onChange1 = jest.fn();
    var onChange2 = jest.fn();
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_RadioGroup.default, {
      id: "test-radio-group"
    }, /*#__PURE__*/_react.default.createElement(TestRadio, {
      value: 1,
      checked: false,
      onChange: onChange1
    }), /*#__PURE__*/_react.default.createElement(TestRadio, {
      value: 2,
      checked: false,
      onChange: onChange2
    })));
    expect(wrapper.state('value')).toBeNull();
    var input = wrapper.find('.za-radio-group__inner').children().at(0).find('input');
    expect(input.props()).toEqual({
      value: 1,
      checked: false,
      type: undefined,
      shape: 'radius',
      disabled: false,
      onChange: expect.any(Function)
    });
    input.simulate('change');
    expect(onChange1).toBeCalledTimes(1);
    expect(onChange2).not.toBeCalled();
    expect(wrapper.state('value')).toEqual(1);
  });
  it('renders correctly', function () {
    var wrapper = (0, _enzyme.render)( /*#__PURE__*/_react.default.createElement(_index.default.Group, {
      value: "0",
      onChange: jest.fn()
    }, /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "0"
    }, "\u9009\u9879\u4E00"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "1"
    }, "\u9009\u9879\u4E8C"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "2"
    }, "\u9009\u9879\u4E09")));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('receive new value', function () {
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_index.default.Group, {
      value: "0",
      onChange: jest.fn()
    }, /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "0"
    }, "\u9009\u9879\u4E00"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "1"
    }, "\u9009\u9879\u4E8C"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "2"
    }, "\u9009\u9879\u4E09")));
    wrapper.setProps({
      value: '1'
    });
  });
  it('defaultValue', function () {
    var wrapper = (0, _enzyme.render)( /*#__PURE__*/_react.default.createElement(_index.default.Group, {
      defaultValue: "1"
    }, /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "0"
    }, "\u9009\u9879\u4E00"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "1"
    }, "\u9009\u9879\u4E8C"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "2"
    }, "\u9009\u9879\u4E09")));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  });
  it('Radio checked', function () {
    var wrapper = (0, _enzyme.render)( /*#__PURE__*/_react.default.createElement(_index.default.Group, null, /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "0"
    }, "\u9009\u9879\u4E00"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "1",
      checked: true
    }, "\u9009\u9879\u4E8C"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "2"
    }, "\u9009\u9879\u4E09")));
    expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
  }); // 圆角

  it('shape is radius', function () {
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_index.default.Group, {
      shape: "radius"
    }, /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "0"
    }, "\u9009\u9879\u4E00"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "1"
    }, "\u9009\u9879\u4E8C"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "2"
    }, "\u9009\u9879\u4E09")));
    expect(wrapper.find('.za-radio-group').hasClass('za-radio-group--radius')).toBe(true);
  }); // 椭圆角

  it('shape is round', function () {
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_index.default.Group, {
      shape: "round"
    }, /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "0"
    }, "\u9009\u9879\u4E00"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "1"
    }, "\u9009\u9879\u4E8C"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "2"
    }, "\u9009\u9879\u4E09")));
    expect(wrapper.find('.za-radio-group').hasClass('za-radio-group--round')).toBe(true);
  }); // 块级样式

  it('block', function () {
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_index.default.Group, {
      block: true
    }, /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "0"
    }, "\u9009\u9879\u4E00"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "1"
    }, "\u9009\u9879\u4E8C"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "2"
    }, "\u9009\u9879\u4E09")));
    expect(wrapper.find('.za-radio-group').hasClass('za-radio-group--block')).toBe(true);
  }); // 列表样式

  it('type is cell', function () {
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_index.default.Group, {
      type: "cell"
    }, /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "0"
    }, "\u9009\u9879\u4E00"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "1"
    }, "\u9009\u9879\u4E8C"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "2",
      disabled: true
    }, "\u9009\u9879\u4E09")));
    expect(wrapper.find('.za-radio-group').hasClass('za-radio-group--cell')).toBe(true);
  });
  it('radio group onChange event', function () {
    var onChange = jest.fn();
    var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_index.default.Group, {
      shape: "round",
      onChange: onChange
    }, /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "0"
    }, "\u9009\u9879\u4E00"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "1"
    }, "\u9009\u9879\u4E8C"), /*#__PURE__*/_react.default.createElement(_index.default, {
      value: "2",
      disabled: true
    }, "\u9009\u9879\u4E09")));
    var firstCheckbox = wrapper.find(_index.default).first().dive().find('input[type="radio"]');
    firstCheckbox.simulate('change', {
      target: {
        checked: true
      }
    });
    expect(onChange).toBeCalledWith('0');
  });
});