"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isCascader = exports.isNumber = exports.isObject = exports.isString = exports.isArray = void 0;

var isArray = function isArray(val) {
  return Object.prototype.toString.call(val) === '[object Array]';
};

exports.isArray = isArray;

var isString = function isString(val) {
  return Object.prototype.toString.call(val) === '[object String]';
};

exports.isString = isString;

var isObject = function isObject(val) {
  return Object.prototype.toString.call(val) === '[object Object]';
};

exports.isObject = isObject;

var isNumber = function isNumber(val) {
  return Object.prototype.toString.call(val) === '[object Number]';
};

exports.isNumber = isNumber;

var isCascader = function isCascader(_ref) {
  var dataSource = _ref.dataSource;
  return dataSource && dataSource[0] && !isArray(dataSource[0]);
};

exports.isCascader = isCascader;