import { PureComponent, CSSProperties } from 'react';
import PropsType from './PropsType';
import actionsheetStyle from './style/index.native';
export interface ButtonProps extends PropsType {
    style?: CSSProperties;
    styles?: typeof actionsheetStyle;
}
export default class ActionSheet extends PureComponent<ButtonProps, any> {
    static defaultProps: {
        visible: boolean;
        spacing: boolean;
        actions: never[];
        cancelText: string;
        styles: any;
    };
    state: {
        isActive: boolean;
        activeIndex: null;
    };
    onPressIn: (activeIndex: any) => void;
    onPressOut: (activeIndex: any) => void;
    renderActions: (action: any, index: any) => JSX.Element;
    renderCancel: () => false | JSX.Element;
    render(): JSX.Element;
}
