import React, { PureComponent } from 'react';
import { AffixProps as BaseAffixProps } from './PropsType';
export interface AffixStates {
    affixed: boolean;
    width: number;
    height: number;
}
export interface AffixProps extends BaseAffixProps {
    prefixCls?: string;
    className?: string;
}
export default class Affix extends PureComponent<AffixProps, AffixStates> {
    static displayName: string;
    static defaultProps: AffixProps;
    private savePlaceholderNode;
    private saveFixedNode;
    private saveFixedNodeTop;
    state: {
        affixed: boolean;
        width: number;
        height: number;
    };
    componentDidMount(): void;
    componentWillUnmount(): void;
    onPositionUpdate: (...args: any[]) => void;
    get container(): HTMLElement | Window | undefined;
    get containerRect(): DOMRect;
    get affixed(): boolean;
    get affixStyle(): React.CSSProperties;
    render(): JSX.Element;
}
