import { PureComponent, MouseEventHandler, AnchorHTMLAttributes, ButtonHTMLAttributes } from 'react';
import BasePropsType from './PropsType';
interface BaseButtonPropsType extends BasePropsType {
    prefixCls?: string;
    onClick?: MouseEventHandler<HTMLElement>;
}
export declare type AnchorButtonProps = {
    mimeType?: string;
} & BaseButtonPropsType & Omit<AnchorHTMLAttributes<HTMLAnchorElement>, 'type' | 'onClick'>;
export declare type NativeButtonProps = {
    htmlType?: 'button' | 'submit' | 'reset';
} & BaseButtonPropsType & Omit<ButtonHTMLAttributes<HTMLButtonElement>, 'type' | 'onClick'>;
export declare type ButtonProps = Partial<AnchorButtonProps & NativeButtonProps>;
export default class Button extends PureComponent<ButtonProps, {}> {
    static displayName: string;
    static defaultProps: ButtonProps;
    onClick: ButtonProps['onClick'];
    render(): JSX.Element;
}
export {};
