import { PureComponent, CSSProperties } from 'react';
import { GestureResponderEvent } from 'react-native';
import PropsType from './PropsType';
import buttonStyle from './style/index.native';
export interface ButtonProps extends PropsType {
    style?: CSSProperties;
    styles?: typeof buttonStyle;
    onClick?: (event: GestureResponderEvent) => void;
}
export default class Button extends PureComponent<ButtonProps, any> {
    static defaultProps: {
        theme: string;
        size: string;
        shape: string;
        block: boolean;
        ghost: boolean;
        disabled: boolean;
        loading: boolean;
        styles: any;
    };
    constructor(props: any);
    onPressIn: () => void;
    onPressOut: () => void;
    render(): JSX.Element;
}
