import React, { PureComponent, HTMLAttributes } from 'react';
import { BaseCheckboxGroupProps } from './PropsType';
export interface CheckboxGroupProps extends Omit<HTMLAttributes<HTMLDivElement>, 'defaultValue' | 'value' | 'onChange'>, BaseCheckboxGroupProps {
    prefixCls?: string;
}
export interface CheckboxGroupStates {
    value?: Array<number | string>;
}
export default class CheckboxGroup extends PureComponent<CheckboxGroupProps, CheckboxGroupStates> {
    static displayName: string;
    static defaultProps: CheckboxGroupProps;
    constructor(props: CheckboxGroup['props']);
    static getDerivedStateFromProps(nextProps: CheckboxGroup['props']): {
        value: React.ReactText[] | undefined;
    } | null;
    onChildChange: (value: string | number) => void;
    render(): JSX.Element;
}
