import { PureComponent } from 'react';
import type { Context } from 'react';
import type { ConfigProviderProps, Locale } from './PropsType';
export declare const LocaleContext: Context<Locale>;
export declare const ConfigContext: Context<ConfigProviderProps>;
export declare const getRunTimeLocale: () => {
    locale: string;
    ActionSheet: {
        cancelText: string;
    };
    Alert: {
        cancelText: string;
    };
    Calendar: {
        weeks: string[];
        months: string[];
        yearText: string;
    };
    Confirm: {
        cancelText: string;
        okText: string;
    };
    DatePicker: {
        cancelText: string;
        okText: string;
        title: string;
    };
    DatePickerView: {
        year: string;
        month: string;
        day: string;
        hour: string;
        minute: string;
    };
    DateSelect: {
        placeholder: string;
    };
    Picker: {
        cancelText: string;
        okText: string;
        title: string;
    };
    StackPicker: {
        cancelText: string;
        okText: string;
    };
    Pull: {
        pullText: string;
        dropText: string;
        loadingText: string;
        successText: string;
        failureText: string;
        completeText: string;
    };
    SearchBar: {
        placeholder: string;
        cancelText: string;
    };
    Select: {
        placeholder: string;
    };
    Keyboard: {
        okText: string;
    };
    ImagePreview: {
        loadBefore: string;
        loadStart: string;
        loadEnd: string;
    };
};
export default class ConfigProvider extends PureComponent<ConfigProviderProps, {}> {
    static defaultProps: ConfigProviderProps;
    componentDidMount(): void;
    componentDidUpdate(): void;
    update(): void;
    render(): JSX.Element;
}
