/**
 * 设置选择前的方法，获取选择文件的相关信息。
 *
 * multiple: 默认为 false，设置为 true 之后一次可以选择多张，onChange 事件调用之后返回一个数组，
 *           不设置或者设置为 false，onChange 事件调用之后返回一个对象
 * disabled: 传递之后不可以点击上传，整个选择组件会设置为半透明状态，透明度为 0.5
 * maximum: 允许选择几张图片，默认为 5
 * accept: 设置选择的文件类型，默认为图片，参数有 'images/* | Photos | Videos | All'
 * onChange: () => { file, fileType, fileSize, fileName, thumbnail }
 * onBeforeSelect: () => boolean，返回 false 的时候阻止后续的选择事件
 */
import { PureComponent } from 'react';
import PropsType from './PropsType';
import filePickerStyle from './style/index.native';
export interface FilePickerProps extends PropsType {
    styles?: typeof filePickerStyle;
    onBeforeSelect: () => boolean;
    onChange: (file: Object | Array<Object>) => void;
    multiple: boolean;
    accept: string;
}
export default class FilePicker extends PureComponent<FilePickerProps, any> {
    static defaultProps: {
        accept: string;
        disabled: boolean;
        multiple: boolean;
        styles: any;
        onBeforeSelect(): boolean;
        onChange(): void;
    };
    state: {
        isShowRoll: boolean;
        imageList: never[];
        selectedImages: never[];
    };
    getFileInfo: (file: any) => any;
    handleShowCameraRoll: () => void;
    getSelectedImages: (images: any) => void;
    handleConfirm: () => void;
    render(): JSX.Element;
}
