import { PureComponent } from 'react';
import type { TouchEvent, MouseEvent } from 'react';
import type PropsType from './PropsType';
export interface KeyboardProps extends PropsType {
    prefixCls?: string;
    className?: string;
}
export default class Keyboard extends PureComponent<KeyboardProps, {}> {
    static defaultProps: KeyboardProps;
    private touchLongPressTimer;
    private mouseLongPressTimer;
    onTouchLongPressIn: (key: string) => void;
    onTouchLongPressOut: (e: TouchEvent<HTMLDivElement> | MouseEvent<HTMLDivElement>) => void;
    onMouseLongPressIn: (key: string) => void;
    onMouseLongPressOut: (e: TouchEvent<HTMLDivElement> | MouseEvent<HTMLDivElement>) => void;
    onKeyClick: (key: string) => void;
    getKeys: () => ReadonlyArray<string>;
    renderKey: (text: string, index: number) => JSX.Element;
    render(): JSX.Element;
}
