import { PureComponent, CSSProperties } from 'react';
import { GestureResponderEvent } from 'react-native';
import PropsType from './PropsType';
import messageStyle from './style/index.native';
export interface MessageProps extends PropsType {
    style?: CSSProperties;
    styles?: typeof messageStyle;
    onClick?: (event: GestureResponderEvent) => void;
}
export interface MessageState {
    visible?: boolean;
}
export default class Message extends PureComponent<MessageProps, MessageState> {
    static defaultProps: {
        theme: string;
        size: string;
        hasArrow: boolean;
        closable: boolean;
        styles: any;
    };
    constructor(props: MessageProps);
    onPressClose: () => void;
    render(): false | JSX.Element | undefined;
}
