import { PureComponent, CSSProperties } from 'react';
import PropsType from './PropsType';
import noticeBarStyle from './style/index.native';
export interface NoticeBarProps extends PropsType {
    style?: CSSProperties;
    styles?: typeof noticeBarStyle;
}
export interface NoticeBarState {
    offset: number;
}
export default class NoticeBar extends PureComponent<NoticeBarProps, NoticeBarState> {
    static defaultProps: {
        theme: string;
        hasArrow: boolean;
        closable: boolean;
        speed: number;
        delay: number;
        styles: any;
    };
    private content;
    private wrapper;
    private moveInterval;
    constructor(props: NoticeBarProps);
    componentDidMount(): Promise<void>;
    componentWillUnmount(): void;
    layout: (ref: any) => Promise<number>;
    render(): JSX.Element;
}
