import React from 'react';
import { ContainerType } from '../utils/dom';
export declare type PopperPlacement = 'top' | 'left' | 'right' | 'bottom' | 'topLeft' | 'topRight' | 'bottomLeft' | 'bottomRight' | 'leftTop' | 'leftBottom' | 'rightTop' | 'rightBottom';
export declare type PopperTrigger = 'hover' | 'focus' | 'click' | 'manual' | 'contextMenu';
export default interface BasePopperProps {
    visible?: boolean;
    hasArrow?: boolean;
    arrowPointAtCenter?: boolean;
    direction?: PopperPlacement;
    trigger?: PopperTrigger;
    animationType?: string;
    animationDuration?: number;
    content?: React.ReactNode;
    destroy?: boolean;
    mountContainer?: ContainerType;
    mouseEnterDelay?: number;
    mouseLeaveDelay?: number;
    onVisibleChange?: (visible: boolean) => void;
}
export declare const directionMap: {
    top: "top";
    topLeft: "top-start";
    topRight: "top-end";
    right: "right";
    rightTop: "right-start";
    rightBottom: "right-end";
    bottom: "bottom";
    bottomLeft: "bottom-start";
    bottomRight: "bottom-end";
    left: "left";
    leftTop: "left-start";
    leftBottom: "left-end";
};
