import { PureComponent } from 'react';
import type PropsType from './PropsType';
import Portal from './Portal';
export interface PopupProps extends PropsType {
    prefixCls?: string;
    className?: string;
}
export interface PopupState {
    renderPortal?: boolean;
    portalVisible: boolean;
}
export default class Popup extends PureComponent<PopupProps, PopupState> {
    static defaultProps: PopupProps;
    portalRef: Portal | null;
    static getDerivedStateFromProps(props: PopupProps, state: PopupState): {
        renderPortal: boolean;
        portalVisible: boolean;
    } | {
        portalVisible: boolean;
        renderPortal?: undefined;
    } | null;
    constructor(props: any);
    componentDidMount(): void;
    handlePortalUnmount(): void;
    render(): false | JSX.Element | undefined;
}
