import { CSSProperties, ReactNode } from 'react';
export declare type KnownSize = 'lg' | 'md' | 'sm';
export declare type ProgressTheme = 'primary' | 'success' | 'warning' | 'danger';
export declare type ProgressSize = KnownSize | number | string;
export declare type ProgressShape = 'line' | 'circle' | 'semi-circle';
export declare type ProgressStrokeShape = 'round' | 'rect';
export declare type ProgressPercent = number;
export declare type PercentFormatter = (percent?: number) => ReactNode;
export default interface PropsType {
    prefixCls: string;
    theme?: ProgressTheme;
    shape?: ProgressShape;
    size?: ProgressSize;
    percent?: ProgressPercent;
    strokeShape?: ProgressStrokeShape;
    strokeWidth?: number;
    text?: PercentFormatter;
    style?: CSSProperties;
    className?: string;
}
