import { HTMLAttributes, PureComponent } from 'react';
import { BaseRadioGroupProps, RadioValue } from './PropsType';
import { Nullable } from '../utils/utilityTypes';
export interface RadioGroupProps extends Omit<HTMLAttributes<HTMLDivElement>, 'defaultValue' | 'value' | 'onChange'>, BaseRadioGroupProps {
    prefixCls?: string;
}
export interface RadioGroupStates {
    value?: Nullable<RadioValue>;
}
export default class RadioGroup extends PureComponent<RadioGroupProps, RadioGroupStates> {
    static displayName: string;
    static defaultProps: {
        prefixCls: string;
        shape: string;
        block: boolean;
        disabled: boolean;
        compact: boolean;
        ghost: boolean;
        size: string;
    };
    state: RadioGroupStates;
    static getDerivedStateFromProps(nextProps: RadioGroup['props']): {
        value: string | number | undefined;
    } | null;
    onChildChange: (value: string | number) => void;
    render(): JSX.Element;
}
