import { PureComponent } from 'react';
import type { ContainerType } from '../utils/dom';
export interface ScrollerProps {
    prefixCls?: string;
    container?: ContainerType;
    onScroll?: (scrollTop?: number) => void;
}
export default class Scroller extends PureComponent<ScrollerProps, {}> {
    static displayName: string;
    static defaultProps: Partial<ScrollerProps>;
    private mounted;
    private scrollThrottled;
    componentDidMount(): void;
    componentDidUpdate(prevProps: ScrollerProps): void;
    componentWillUnmount(): void;
    get scrollContainer(): HTMLElement | Window;
    get scrollTop(): number;
    onScroll: () => void;
    bindEvent: () => void;
    unBindEvent: () => void;
    render(): {} | null;
}
