import React, { PureComponent } from 'react';
import PropsType from './PropsType';
export interface StepperProps extends PropsType {
    prefixCls?: string;
    className?: string;
}
export interface StepperStates {
    value: number | string;
    prevPropsValue: number | string;
    lastValue: number | string;
}
export default class Stepper extends PureComponent<StepperProps, StepperStates> {
    static displayName: string;
    static defaultProps: StepperProps;
    state: StepperStates;
    static getDerivedStateFromProps(nextProps: StepperProps, prevState: StepperStates): {
        value: React.ReactText;
        lastValue: React.ReactText;
        prevPropsValue: React.ReactText;
    } | null;
    onInputChange: (value: string | number) => void;
    onInputBlur: (value: number | string) => void;
    onSubClick: () => void;
    onPlusClick: () => void;
    isSubDisabled: () => boolean | undefined;
    isPlusDisabled: () => boolean | undefined;
    render(): JSX.Element;
}
