import { PureComponent } from 'react';
import type { HTMLAttributes } from 'react';
import type PropsType from './PropsType';
export declare type SwitchProps = {
    prefixCls?: string;
} & Omit<HTMLAttributes<HTMLSpanElement>, 'onChange'> & PropsType;
export interface SwitchStates {
    checked: boolean;
}
export default class Switch extends PureComponent<SwitchProps, SwitchStates> {
    static displayName: string;
    static defaultProps: SwitchProps;
    state: SwitchStates;
    static getDerivedStateFromProps(nextProps: SwitchProps): {
        checked: boolean;
    } | null;
    onValueChange: () => void;
    render(): JSX.Element;
}
